diff -r 091f89c47ad9 trytond/modules/stock/shipment.py
--- a/trytond/modules/stock/shipment.py	Mon Sep 10 15:28:38 2012 +0200
+++ b/trytond/modules/stock/shipment.py	Mon Sep 24 20:36:42 2012 +0200
@@ -2139,44 +2049,42 @@
             ])
     force = StateTransition()
 
-    def transition_start(self, session):
+    def transition_start(self):
         pool = Pool()
-        shipment_obj = pool.get('stock.shipment.in.return')
+        Shipment = pool.get('stock.shipment.in.return')
 
-        if shipment_obj.assign_try([Transaction().context['active_id']]):
+        if Shipment.assign_try([Shipment(Transaction().context['active_id'])]):
             return 'end'
         else:
             return 'failed'
 
-    def transition_force(self, session):
-        shipment_obj = Pool().get('stock.shipment.in.return')
+    def transition_force(self):
+        Shipment = Pool().get('stock.shipment.in.return')
 
-        shipment_obj.assign_force([Transaction().context['active_id']])
+        Shipment.assign_force([Shipment(Transaction().context['active_id'])])
         return 'end'
 
-AssignShipmentInReturn()
-
 
 class CreateShipmentOutReturn(Wizard):
     'Create Customer Return Shipment'
-    _name = 'stock.shipment.out.return.create'
-
+    __name__ = 'stock.shipment.out.return.create'
     start = StateAction('stock.act_shipment_out_return_form')
 
-    def __init__(self):
-        super(CreateShipmentOutReturn, self).__init__()
-        self._error_messages.update({
+    @classmethod
+    def __setup__(cls):
+        super(CreateShipmentOutReturn, cls).__setup__()
+        cls._error_messages.update({
             'shipment_done_title': 'You can not create return shipment',
             'shipment_done_msg': 'The shipment with code %s is not yet sent.',
             })
 
-    def do_start(self, session, action):
+    def do_start(self, action):
         pool = Pool()
-        shipment_out_obj = pool.get('stock.shipment.out')
-        shipment_out_return_obj = pool.get('stock.shipment.out.return')
+        ShipmentOut = pool.get('stock.shipment.out')
+        ShipmentOutReturn = pool.get('stock.shipment.out.return')
 
         shipment_ids = Transaction().context['active_ids']
-        shipment_outs = shipment_out_obj.browse(shipment_ids)
+        shipment_outs = ShipmentOut.browse(shipment_ids)
 
         shipment_out_return_ids = []
         for shipment_out in shipment_outs:
@@ -2197,12 +2105,12 @@
                             'company': move.company.id,
                             }))
             shipment_out_return_ids.append(
-                shipment_out_return_obj.create({
+                ShipmentOutReturn.create({
                     'customer': shipment_out.customer.id,
                     'delivery_address': shipment_out.delivery_address.id,
                     'warehouse': shipment_out.warehouse.id,
                     'incoming_moves': incoming_moves,
-                    })
+                    }).id
                 )
 
         data = {'res_id': shipment_out_return_ids}
@@ -2210,50 +2118,52 @@
             action['views'].reverse()
         return action, data
 
-    def transition_start(self, session):
+    def transition_start(self):
         return 'end'
 
-CreateShipmentOutReturn()
-
 
 class DeliveryNote(CompanyReport):
-    _name = 'stock.shipment.out.delivery_note'
+    'Delivery Note'
+    __name__ = 'stock.shipment.out.delivery_note'
 
-    def parse(self, report, objects, datas, localcontext):
+    @classmethod
+    def parse(cls, report, objects, data, localcontext):
         localcontext['product_name'] = lambda product_id, language: \
-                self.product_name(product_id, language)
-        return super(DeliveryNote, self).parse(report, objects, datas,
+                cls.product_name(product_id, language)
+        return super(DeliveryNote, cls).parse(report, objects, data,
                 localcontext)
 
-    def product_name(self, product_id, language):
-        product_obj = Pool().get('product.product')
+    @classmethod
+    def product_name(cls, product_id, language):
+        Product = Pool().get('product.product')
         with Transaction().set_context(language=language):
-            return product_obj.browse(product_id).rec_name
-
-DeliveryNote()
+            return Product(product_id).rec_name
 
 
 class PickingList(CompanyReport):
-    _name = 'stock.shipment.out.picking_list'
+    'Picking List'
+    __name__ = 'stock.shipment.out.picking_list'
 
-    def parse(self, report, objects, datas, localcontext):
-        compare_context = self.get_compare_context(report, objects, datas)
+    @classmethod
+    def parse(cls, report, objects, data, localcontext):
+        compare_context = cls.get_compare_context(report, objects, data)
 
         sorted_moves = {}
         for shipment in objects:
             sorted_moves[shipment.id] = sorted(
                 shipment.inventory_moves,
-                lambda x, y: cmp(self.get_compare_key(x, compare_context),
-                    self.get_compare_key(y, compare_context))
+                lambda x, y: cmp(cls.get_compare_key(x, compare_context),
+                    cls.get_compare_key(y, compare_context))
                 )
 
         localcontext['moves'] = sorted_moves
 
-        return super(PickingList, self).parse(report, objects, datas,
-                localcontext)
+        return super(PickingList, cls).parse(report, objects, data,
+            localcontext)
 
-    def get_compare_context(self, report, objects, datas):
-        location_obj = Pool().get('stock.location')
+    @staticmethod
+    def get_compare_context(report, objects, data):
+        Location = Pool().get('stock.location')
         from_location_ids = set()
         to_location_ids = set()
         for obj in objects:
@@ -2261,44 +2171,46 @@
                 from_location_ids.add(move.from_location.id)
                 to_location_ids.add(move.to_location.id)
 
-        from_location_ids = location_obj.search(list(from_location_ids))
-        to_location_ids = location_obj.search(list(to_location_ids))
+        from_locations = Location.search(list(from_location_ids))
+        to_locations = Location.search(list(to_location_ids))
 
         return {
-            'from_location_ids': from_location_ids,
-            'to_location_ids': to_location_ids,
+            'from_location_ids': [l.id for l in from_locations],
+            'to_location_ids': [l.id for l in to_locations],
             }
 
-    def get_compare_key(self, move, compare_context):
+    @staticmethod
+    def get_compare_key(move, compare_context):
         from_location_ids = compare_context['from_location_ids']
         to_location_ids = compare_context['to_location_ids']
         return [from_location_ids.index(move.from_location.id),
                 to_location_ids.index(move.to_location.id)]
 
-PickingList()
-
 
 class SupplierRestockingList(CompanyReport):
-    _name = 'stock.shipment.in.restocking_list'
+    'Supplier Restocking List'
+    __name__ = 'stock.shipment.in.restocking_list'
 
-    def parse(self, report, objects, datas, localcontext):
-        compare_context = self.get_compare_context(report, objects, datas)
+    @classmethod
+    def parse(cls, report, objects, data, localcontext):
+        compare_context = cls.get_compare_context(report, objects, data)
 
         sorted_moves = {}
         for shipment in objects:
             sorted_moves[shipment.id] = sorted(
                 shipment.inventory_moves,
-                lambda x, y: cmp(self.get_compare_key(x, compare_context),
-                    self.get_compare_key(y, compare_context))
+                lambda x, y: cmp(cls.get_compare_key(x, compare_context),
+                    cls.get_compare_key(y, compare_context))
                 )
 
         localcontext['moves'] = sorted_moves
 
-        return super(SupplierRestockingList, self).parse(report, objects,
-                datas, localcontext)
+        return super(SupplierRestockingList, cls).parse(report, objects,
+                data, localcontext)
 
-    def get_compare_context(self, report, objects, datas):
-        location_obj = Pool().get('stock.location')
+    @staticmethod
+    def get_compare_context(report, objects, data):
+        Location = Pool().get('stock.location')
         from_location_ids = set()
         to_location_ids = set()
         for obj in objects:
@@ -2306,44 +2218,46 @@
                 from_location_ids.add(move.from_location.id)
                 to_location_ids.add(move.to_location.id)
 
-        from_location_ids = location_obj.search(list(from_location_ids))
-        to_location_ids = location_obj.search(list(to_location_ids))
+        from_locations = Location.search(list(from_location_ids))
+        to_locations = Location.search(list(to_location_ids))
 
         return {
-            'from_location_ids': from_location_ids,
-            'to_location_ids': to_location_ids,
+            'from_location_ids': [l.id for l in from_locations],
+            'to_location_ids': [l.id for l in to_locations],
             }
 
-    def get_compare_key(self, move, compare_context):
+    @staticmethod
+    def get_compare_key(move, compare_context):
         from_location_ids = compare_context['from_location_ids']
         to_location_ids = compare_context['to_location_ids']
         return [from_location_ids.index(move.from_location.id),
                 to_location_ids.index(move.to_location.id)]
 
-SupplierRestockingList()
-
 
 class CustomerReturnRestockingList(CompanyReport):
-    _name = 'stock.shipment.out.return.restocking_list'
+    'Customer Return Restocking List'
+    __name__ = 'stock.shipment.out.return.restocking_list'
 
-    def parse(self, report, objects, datas, localcontext):
-        compare_context = self.get_compare_context(report, objects, datas)
+    @classmethod
+    def parse(cls, report, objects, data, localcontext):
+        compare_context = cls.get_compare_context(report, objects, data)
 
         sorted_moves = {}
         for shipment in objects:
             sorted_moves[shipment.id] = sorted(
                 shipment.inventory_moves,
-                lambda x, y: cmp(self.get_compare_key(x, compare_context),
-                    self.get_compare_key(y, compare_context))
+                lambda x, y: cmp(cls.get_compare_key(x, compare_context),
+                    cls.get_compare_key(y, compare_context))
                 )
 
         localcontext['moves'] = sorted_moves
 
-        return super(CustomerReturnRestockingList, self).parse(report,
-                objects, datas, localcontext)
+        return super(CustomerReturnRestockingList, cls).parse(report,
+                objects, data, localcontext)
 
-    def get_compare_context(self, report, objects, datas):
-        location_obj = Pool().get('stock.location')
+    @staticmethod
+    def get_compare_context(report, objects, data):
+        Location = Pool().get('stock.location')
         from_location_ids = set()
         to_location_ids = set()
         for obj in objects:
@@ -2351,44 +2265,46 @@
                 from_location_ids.add(move.from_location.id)
                 to_location_ids.add(move.to_location.id)
 
-        from_location_ids = location_obj.search(list(from_location_ids))
-        to_location_ids = location_obj.search(list(to_location_ids))
+        from_locations = Location.search(list(from_location_ids))
+        to_locations = Location.search(list(to_location_ids))
 
         return {
-            'from_location_ids': from_location_ids,
-            'to_location_ids': to_location_ids,
+            'from_location_ids': [l.id for l in from_locations],
+            'to_location_ids': [l.id for l in to_locations],
             }
 
-    def get_compare_key(self, move, compare_context):
+    @staticmethod
+    def get_compare_key(move, compare_context):
         from_location_ids = compare_context['from_location_ids']
         to_location_ids = compare_context['to_location_ids']
         return [from_location_ids.index(move.from_location.id),
                 to_location_ids.index(move.to_location.id)]
 
-CustomerReturnRestockingList()
-
 
 class InteralShipmentReport(CompanyReport):
-    _name = 'stock.shipment.internal.report'
+    'Interal Shipment Report'
+    __name__ = 'stock.shipment.internal.report'
 
-    def parse(self, report, objects, datas, localcontext=None):
-        compare_context = self.get_compare_context(report, objects, datas)
+    @classmethod
+    def parse(cls, report, objects, data, localcontext=None):
+        compare_context = cls.get_compare_context(report, objects, data)
 
         sorted_moves = {}
         for shipment in objects:
             sorted_moves[shipment.id] = sorted(
                 shipment.moves,
-                lambda x, y: cmp(self.get_compare_key(x, compare_context),
-                    self.get_compare_key(y, compare_context))
+                lambda x, y: cmp(cls.get_compare_key(x, compare_context),
+                    cls.get_compare_key(y, compare_context))
                 )
 
         localcontext['moves'] = sorted_moves
 
-        return super(InteralShipmentReport, self).parse(report, objects,
-                datas, localcontext)
+        return super(InteralShipmentReport, cls).parse(report, objects,
+            data, localcontext)
 
-    def get_compare_context(self, report, objects, datas):
-        location_obj = Pool().get('stock.location')
+    @staticmethod
+    def get_compare_context(report, objects, data):
+        Location = Pool().get('stock.location')
         from_location_ids = set()
         to_location_ids = set()
         for obj in objects:
@@ -2396,18 +2312,17 @@
                 from_location_ids.add(move.from_location.id)
                 to_location_ids.add(move.to_location.id)
 
-        from_location_ids = location_obj.search(list(from_location_ids))
-        to_location_ids = location_obj.search(list(to_location_ids))
+        from_locations = Location.search(list(from_location_ids))
+        to_locations = Location.search(list(to_location_ids))
 
         return {
-            'from_location_ids': from_location_ids,
-            'to_location_ids': to_location_ids,
+            'from_location_ids': [l.id for l in from_locations],
+            'to_location_ids': [l.id for l in to_locations],
             }
 
-    def get_compare_key(self, move, compare_context):
+    @staticmethod
+    def get_compare_key(move, compare_context):
         from_location_ids = compare_context['from_location_ids']
         to_location_ids = compare_context['to_location_ids']
         return [from_location_ids.index(move.from_location.id),
                 to_location_ids.index(move.to_location.id)]
-
-InteralShipmentReport()
